/*
 * sqmgrlog - Squid user management log
 * Mar/98 - Pedro L Orso - orso@onda.com.br
 */

#include "conf.h"
#include "extern.h"

void siteuser(const char *dirname, int *debug, const char *outdir, int *userip, char *BgColor, char *TxColor, char *TxBgColor, char *TiColor, char *LogoImage, char *LogoText, char *LogoTextColor, char *Width, char *Height, char *Title, char *BgImage, char *FontFace, char *HeaderColor, char *HeaderBgColor, char *FontSize, char *TempDir, char *Ip2Name, char *TopuserSortField, char *TopuserSortOrder, char *UserAgentLog, char *DateFormat)
{

   FILE *fp_in, *fp_ou;
      
   char user[MAXLEN];
   char url[MAXLEN];
   char ouser[MAXLEN];
   char ourl[MAXLEN];
   char nacc[15];
   char nbytes[15];
   char csort[255];
   char geral[MAXLEN];
   char geral2[MAXLEN];
   char per[MAXLEN];
   char html[MAXLEN];
   char sites[MAXLEN];
   char report[MAXLEN];
   char periodo[100];
   char ftime[128];
   int regs=0;

   sprintf(geral,"%s/geral",dirname);
   sprintf(sites,"%s/sites",dirname);
   sprintf(geral2,"%s/geral2",dirname);
   sprintf(per,"%s/periodo",dirname);
   sprintf(report,"%s/siteuser.html",dirname);

   if ((fp_in = fopen(per, "r")) == 0) {
      fprintf(stderr, "SQMGRLOG: (topuser) %s: %s\n",msg42,per);
      exit(1);
   }

   fgets(periodo,sizeof(periodo),fp_in);
   fclose(fp_in);

   sprintf(csort,"sort -n -k 4,4 -k 1,1 -o %s %s",geral2,geral);
   system(csort);

   if((fp_in=fopen(geral2,"r"))==NULL) {
     fprintf(stderr, "SQMGRLOG: (topsite) %s: %s\n",msg05,geral2);
     exit(1);
   }

   if((fp_ou=fopen(report,"w"))==NULL) {
     fprintf(stderr, "SQMGRLOG: (topsite) %s: %s\n",msg05,report);
     exit(1);
   }

   fputs("<html>\n",fp_ou);

   if(strlen(FontFace) > 0) {
      sprintf(url,"<font face=%s>\n",FontFace);
      fputs(url,fp_ou);
   }

   sprintf(url,"<body bgcolor=%s text=%s background='%s'>\n",BgColor,TxColor,BgImage);
   fputs(url,fp_ou);

   fputs("<center><table cellpadding=0 cellspacing=0>\n",fp_ou);

   if(strlen(LogoImage) > 0) {
      sprintf(url,"<tr><th align=left><img src='%s' border=0 align=absmiddle width=%s height=%s><font color=%s>%s</font>\n",LogoImage,Width,Height,LogoTextColor,LogoText);
      fputs(url,fp_ou);
   }

   sprintf(url,"<tr><th align=center><b><font color=%s size=+1>%s</font></b></th></tr>\n",TiColor,Title);
   fputs(url,fp_ou);

   sprintf(url,"<tr><td align=center bgcolor=%s><font size=%s>%s: %s</font></td></tr>\n",HeaderBgColor,FontSize,htm02,periodo);
   fputs(url,fp_ou);
   sprintf(url,"<tr><td align=center bgcolor=%s><font size=%s>%s</font></td></tr>\n",HeaderBgColor,FontSize,msg84);
   fputs(url,fp_ou);
   fputs("</table></center>\n",fp_ou);

   fputs("<center><table cellpadding=0 cellspacing=0>\n",fp_ou);
   fputs("<tr><td></td></tr>\n",fp_ou);
   fputs("<tr><td></td></tr>\n",fp_ou);
   fputs("<tr><td></td></tr>\n",fp_ou);
   sprintf(url,"<tr><th></th><th bgcolor=%s><font size=%s>%s</font></th></tr>\n",HeaderBgColor,FontSize,htm04);
   fputs(url,fp_ou);
  
   regs=1;
   user[0]='\0';
   ourl[0]='\0';

   while(fgets(buf,sizeof(buf),fp_in)!=NULL) {
      getword(user,buf,' ');
      if(userip)
         fixip(user);
      if(strcmp(Ip2Name,"yes") == 0)
         ip2name(user);
      if(strcmp(user,"TOTAL") == 0)
         continue;
      getword(nacc,buf,' ');
      getword(nbytes,buf,' ');
      getword(url,buf,' ');

      if(strcmp(url,ourl) != 0) {
         sprintf(html,"<tr><td bgcolor=%s align=right><font size=%s>%d</font></td><td align=right border=0 bgcolor=%s><font size=%s><a href=\"http://%s\">%s</font></td></tr>\n",TxBgColor,FontSize,regs,TxBgColor,FontSize,url,url);
         fputs(html,fp_ou);
         regs++;
         ouser[0]='\0';
      }

      if(strcmp(user,ouser) != 0) {
         sprintf(html,"<tr><td></td><td bgcolor=%s align=right><font size=%s>%s</font></td></tr>\n",TxBgColor,FontSize,user);
         fputs(html,fp_ou);
      }

      strcpy(ourl,url);
      strcpy(ouser,user);


   }
   unlink(geral2);

   fputs("</table></center>\n",fp_ou);

   zdate(ftime, DateFormat);
   sprintf(ourl,"<br><br><center><font size=-2>%s <a href='%s'>%s-%s</a> %s %s</font></center>\n",htm21,URL,PGM,VERSION,htm22,ftime);
   fputs(ourl,fp_ou);

   fputs("</html>\n",fp_ou);
   
   fclose(fp_in);
   fclose(fp_ou);

   return;

}
