/*
 * sqmgrlog - Squid user management log
 * Mar/98 - Pedro L Orso - orso@onda.com.br
 */

#include "conf.h"
#include "extern.h"


void totaliza_day(const char *dirname, char *user, int *indexonly)
{

   FILE *fp_in, *fp_ou;
      
   char data[15];
   char hora[15];
   char min[15];
   char elap[15];
   char odata[15];
   char ohora[15];
   char oelap[15];
   char hm[15];
   char ohm[15];
   char whora[3];
   char csort[255];
   char wdirname[MAXLEN];
   char sortout[MAXLEN];
   char arqout[MAXLEN];
   int  regs=0;
   long int telap=0;
   long int tused=0;

   if(indexonly)
      return;

   sprintf(wdirname,"%s/%s.htmp",dirname,user);
   sprintf(arqout,"%s/%s.day",dirname,user);
   sprintf(sortout,"%s/%s.sort",dirname,user);

   sprintf(csort,"sort -n -k 1,1 -k 2,2 -o %s %s",sortout,wdirname);
   system(csort);

   unlink(wdirname);

   if((fp_in=fopen(sortout,"r"))==NULL) {
     fprintf(stderr, "SQMGRLOG: (totday) %s: %s\n",msg05,sortout);
     exit(1);
   }

   if((fp_ou=fopen(arqout,"w"))==NULL) {
     fprintf(stderr, "SQMGRLOG: (totday) %s: %s\n",msg05,arqout);
     exit(1);
   }

   while(fgets(buf,sizeof(buf),fp_in)!=NULL) {
      if(strstr(buf,"\n") != 0)
         buf[strlen(buf)-1]='\0';
         
      getword(data,buf,' ');
      getword(hora,buf,':');
      getword(min,buf,':');
      getword(elap,buf,' ');
      strcpy(elap,buf);
      sprintf(hm,"%s%s",hora,min);

      if(!regs) {
         strcpy(odata,data);
         strcpy(ohora,hora);
         strcpy(oelap,elap);
         strcpy(ohm,hm);
         regs++;
      }

      if(strcmp(hora,ohora) != 0) {
         if(tused > telap)
            tused=telap;
         sprintf(buf,"%s %s %010d\n",odata,ohora,tused);
         fputs(buf, fp_ou);
         strcpy(odata,data);
         strcpy(ohora,hora);
         strcpy(ohm,hm);
         telap=0;
         tused=0;
      }

      if(strcmp(ohm,hm) != 0) {
         tused+=60000;
         strcpy(ohm,hm);
      }

      telap+=atol(elap);
          
   }

   if(tused > telap)
      tused=telap;
   sprintf(buf,"%s %s %010d\n",data,hora,tused);
   fputs(buf, fp_ou);

   fclose(fp_in);
   fclose(fp_ou);

   unlink(sortout);

   return;

}
